﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TheGuards
{
    public partial class frm_main : Form
    {

        int shoutCount = 0;//تعداد موشک های شلیک شده
        int missShout = 0;//تعدا موشک های خطا رفته

        PictureBox[,] enemies;//ماتریس دشمنان
        int enemiesRow = 0;//تعداد سطر های دشمنان
        int enemiesCol = 0;//تعداد ستون های دشمنان

        int verticalSpace = 0;//فاصله عمودی بین دشمنان
        int horizontalSpace = 0;//فاصله افقی بین دشمنان
        int sizeOfEnemies = 0;//اندازه دشمنان
        int totalSize = 0;//مجموع کل اندازه ماتریس




        public frm_main()//اولین متدی که در هنگام ساخت فرم نمایش داده می شود
        {
            InitializeComponent();

            cmb_Theme.SelectedIndex = 0;//برای اینکه اولین عضو انتخاب شود
            rdb_Keyboard.Checked = true;//شلیک با کیبورد را بطور پیش فرض در نظر می گیرد

            this.Size = new Size(1280, 800);//سایز صفحه رو درست تنظیم می کنیم تا در رزولشون های مختلف خراب نشود

            ListViewItem item = new ListViewItem(new[] {"MajidOnline","1000","2015/12/09"});
            lsv_playerListAsc.Items.Add(item);
            ListViewItem item2 = new ListViewItem(new[] { "Artiman Studio", "900", "2015/12/09" });
            lsv_playerListAsc.Items.Add(item2);

            


        }

        private void btn_start_Click(object sender, EventArgs e)
        {
            //تنظیمات اولیه بازی
            gpb_userInformation.Enabled = false;
            gpb_gameInformation.Enabled = false;
            btn_start.Enabled = false;
            btn_stop.Enabled = true;
            ptb_backGround.Enabled = true;
            ptb_spaceShip.Visible = true;
            ptb_spaceShip.Focus();
            lbl_shoutCount.Visible = true;
            lbl_shoutCountText.Visible = true;
            lbl_missShout.Visible = true;
            lbl_missShoutText.Visible = true;
            
            tmr_main.Start();//با فراخوانی این متد تایمر شروع به کار می کند

            

            totalSize = (enemiesCol * sizeOfEnemies) + ((enemiesCol - 1) * horizontalSpace);//محاسبه طول کل ماتریس

            if (totalSize >= 900 || totalSize <= 0)
            {
                enemiesCol = 5;
                enemiesRow = 4;
                sizeOfEnemies = 50;
                horizontalSpace = verticalSpace = 20;
                totalSize = (enemiesCol * sizeOfEnemies) + ((enemiesCol - 1) * horizontalSpace);
            }




            enemies = new PictureBox[enemiesCol, enemiesRow];

           
        }

        private void frm_main_Load(object sender, EventArgs e)
        {
            //اضافه کردن کنترل ها به ptb_backGround
            ptb_backGround.Controls.Add(ptb_spaceShip);
            ptb_backGround.Controls.Add(lbl_shoutCount);
            ptb_backGround.Controls.Add(lbl_shoutCountText);
            ptb_backGround.Controls.Add(lbl_missShout);
            ptb_backGround.Controls.Add(lbl_missShoutText);
        }

        private void btn_exit_Click(object sender, EventArgs e)
        {

            exitFromTheGame();//فراخوانی تابع خروج از برنامه
        }

        private void btn_stop_Click(object sender, EventArgs e)
        {

            frm_pauseMessage f = new frm_pauseMessage();//ساخت فرم نمایش پیغام
            f.ShowDialog();//نمایش فرم نمایش پیغام       

        }

        public static void exitFromTheGame()
        {
            Application.Exit();
        }

        private void ptb_backGround_MouseMove(object sender, MouseEventArgs e)
        {

            if (e.X <= ptb_spaceShip.Size.Width/2)//زمانی که 
            {
                ptb_spaceShip.Location = new Point(0, ptb_spaceShip.Location.Y);
            }
            else if (e.X + ptb_spaceShip.Size.Width/2 >= ptb_backGround.Size.Width)
            {
                ptb_spaceShip.Location = new Point(ptb_backGround.Size.Width - ptb_spaceShip.Size.Width, ptb_spaceShip.Location.Y);
                
            }
            else
                ptb_spaceShip.Location = new Point(e.X - (ptb_spaceShip.Size.Width/2), ptb_spaceShip.Location.Y);
            
        }

        private void rdb_Keyboard_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void ptb_backGround_Click(object sender, EventArgs e)
        {
            if (rdb_Mouse.Checked == true)
                fire();
        }



        private void frm_main_KeyDown(object sender, KeyEventArgs e)
        {

            if (rdb_Keyboard.Checked == true)

                if (e.KeyData == Keys.Space)

                    fire(); 
        }

        void fire()
        {
            Button rocket = new Button();
            rocket.Size = new Size(30, 30);
            rocket.Location = ptb_spaceShip.Location;          
            rocket.FlatStyle = FlatStyle.Flat;
            rocket.FlatAppearance.BorderSize = 0;
            ptb_backGround.Controls.Add(rocket);
            shoutCount++;
            lbl_shoutCount.Text = shoutCount.ToString();   
        }

        private void mainTimer_Tick(object sender, EventArgs e)
        {
            foreach (Control x in ptb_backGround.Controls)
            {
                if (x is Button)
                {
                    x.Location = new Point(x.Location.X, x.Location.Y - 10);

                    if (x.Location.Y <= 0)
                    {
                        ptb_backGround.Controls.Remove(x);
                        x.Dispose();
                        missShout++;
                        lbl_missShout.Text = missShout.ToString();
                        
                    }
                }
            }
        }
    }
}
 